/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.0.2
[T] bitsum class variable instead of array
[T] Ham_Spawn forward instead of zpnm
[T] fix assassin and nemesis having ability when turned into directly from class
v1.0.5
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <bitsums>

// Zombie Attributes
new const zclass_name[] = "Incinerated Zombie" // name
new const zclass_info[] = "Can't be burned" // description
new const zclass_model[] = "zombie_source" // model
new const zclass_clawmodel[] = "zombie_plague/v_knife_zombie.mdl" // claw model
const zclass_health = 1800 // health
const zclass_speed = 190 // speed
const Float:zclass_gravity = 0.75 // gravity
const Float:zclass_knockback = 1.1 // knockback

// Class IDs
new g_iIDClass, g_iBsClass;

// Zombie Classes MUST be registered on plugin_precache
public plugin_precache()
{
	// Register the new class and store ID for reference
	g_iIDClass = zp_register_zombie_class(zclass_name, zclass_info, zclass_model, zclass_clawmodel, zclass_health, zclass_speed, zclass_gravity, zclass_knockback);
}

public plugin_init()
{
	register_plugin("[ZPNM] Incinerated Zombie Class", "1.0.5", "D i 5 7 i n c T")
	
	RegisterHam(Ham_Spawn, "player", "fwHamSpawnPlayerPre")
	RegisterHamBots(Ham_Spawn, "fwHamSpawnPlayerPre")
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayerPre")
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayerPre")
}

public client_putinserver(iID)
	bitsum_del(g_iBsClass, iID)

public fwHamSpawnPlayerPre(const iID)
	bitsum_del(g_iBsClass, iID)

public zp_user_infected_post(iID, iIDAttacker, bNemesis, bAssassin)
{
	if (bNemesis || bAssassin || zp_get_user_zombie_class(iID) != g_iIDClass)
	{
		bitsum_del(g_iBsClass, iID)
		
		return;
	}
	
	bitsum_add(g_iBsClass, iID)
}

public zpnm_user_burn(iID, iIDAttacker)
{
	if (!iIDAttacker || !bitsum_get(g_iBsClass, iID))
		return;
	
	zpnm_set_user_burning(iID, 0)
}

public zp_user_humanized_post(iID)
	bitsum_del(g_iBsClass, iID)

public fwHamKilledPlayerPre(const iID)
	bitsum_del(g_iBsClass, iID)
